Subject: Re: [JGIT PATCH] Fix CanonicalTreeParser.back to parse all trees correctly

From: "Shawn O. Pearce" <[email-masked]>
Date: Fri, 12 Jun 2009 08:08:01 -0700

"Shawn O. Pearce" <[email-masked]> wrote:
> The back(int delta) method needs to walk backwards delta entries in
> the tree we are iterating.  Unfortunately, despite my attempts to do
> so, there is no reliable way to parse a canonical tree in reverse.

Ping?

Without this patch the NameConflictDirWalk can get into some serious
trouble, trouble which can cause Gerrit Code Review to have its
memory explode to >8 GiB, because NCDW gets stuck in an infinite
loop, forever allocating reachable memory inside of a MergeStrategy.

I've made a private build of this and am running it in production
within day-job employer, but I can't make a release of Gerrit until
I have a stable identifier for this patch.
 
>  .../jgit/treewalk/CanonicalTreeParserTest.java     |   78 ++++++++++++++++++-
>  .../spearce/jgit/treewalk/CanonicalTreeParser.java |   74 +++++++++---------
>  2 files changed, 110 insertions(+), 42 deletions(-)

-- 
Shawn.